package eu.eudat.commons.types.descriptiontemplate.fielddata;

import jakarta.xml.bind.annotation.*;

import java.util.List;


@XmlAccessorType(XmlAccessType.FIELD)
public class ExternalSelectDataEntity extends LabelAndMultiplicityDataEntity {
    public static final String XmlElementName = "externalSelectData";

    @XmlAccessorType(XmlAccessType.FIELD)
    public static class ExternalSelectAuthDataEntity {
        @XmlAttribute(name="url")
        private String url;
        @XmlAttribute(name="method")
        private String method;
        @XmlAttribute(name="body")
        private String body;
        @XmlAttribute(name="path")
        private String path;
        @XmlAttribute(name="type")
        private String type;

        public String getUrl() {
            return url;
        }

        public void setUrl(String url) {
            this.url = url;
        }

        public String getMethod() {
            return method;
        }

        public void setMethod(String method) {
            this.method = method;
        }

        public String getBody() {
            return body;
        }

        public void setBody(String body) {
            this.body = body;
        }

        public String getPath() {
            return path;
        }

        public void setPath(String path) {
            this.path = path;
        }

        public String getType() {
            return type;
        }

        public void setType(String type) {
            this.type = type;
        }
    }

    @XmlAccessorType(XmlAccessType.FIELD)
    public static class ExternalSelectSourceBindingEntity {
        @XmlAttribute(name="label")
        private String label;
        @XmlAttribute(name="value")
        private String value;
        @XmlAttribute(name="source")
        private String source;

        public String getLabel() {
            return label;
        }
        public void setLabel(String label) {
            this.label = label;
        }

        public String getValue() {
            return value;
        }
        public void setValue(String value) {
            this.value = value;
        }

        public String getSource() {
            return source;
        }
        public void setSource(String source) {
            this.source = source;
        }
    }

    @XmlAccessorType(XmlAccessType.FIELD)
    public static class ExternalSelectSourceEntity {
        @XmlAttribute(name="url")
        private String url;
        @XmlAttribute(name="method")
        private String method;
        @XmlAttribute(name="optionsRoot")
        private String optionsRoot;
        @XmlElement(name="sourceBinding")
        private ExternalSelectSourceBindingEntity sourceBinding;
        @XmlAttribute(name="hasAuth")
        private Boolean hasAuth;
        @XmlElement(name="auth")
        private ExternalSelectAuthDataEntity auth;

        public String getOptionsRoot() {
            return optionsRoot;
        }
        public void setOptionsRoot(String optionsRoot) {
            this.optionsRoot = optionsRoot;
        }

        public String getUrl() {
            return url;
        }
        public void setUrl(String url) {
            this.url = url;
        }

        public Boolean getHasAuth() {
            return hasAuth;
        }

        public void setHasAuth(Boolean hasAuth) {
            this.hasAuth = hasAuth;
        }

        public ExternalSelectAuthDataEntity getAuth() {
            return auth;
        }

        public void setAuth(ExternalSelectAuthDataEntity auth) {
            this.auth = auth;
        }

        public ExternalSelectSourceBindingEntity getSourceBinding() {
            return sourceBinding;
        }
        public void setSourceBinding(ExternalSelectSourceBindingEntity sourceBinding) {
            this.sourceBinding = sourceBinding;
        }

        public String getMethod() {
            return method;
        }

        public void setMethod(String method) {
            this.method = method;
        }
    }

    @XmlElementWrapper(name = "sources")
    @XmlElement(name = "source")
    private List<ExternalSelectSourceEntity> sources;

    public List<ExternalSelectSourceEntity> getSources() {
        return sources;
    }

    public void setSources(List<ExternalSelectSourceEntity> externalSelectSourceEntityList) {
        this.sources = externalSelectSourceEntityList;
    }
}


